import pandas as pd
import numpy as np
import itertools
def generate_routes(distance_matrix):
    num_installations = 10
    # Number of installations (1 to 10)
    max_route_length = 5  # Maximum route length (including the starting [0])
    df = pd.read_excel('/Users/prebenolsen/Desktop/Master/Modeller/10Inst_Demands-Distances.xlsx', header=None)
    DistMatrix = df.values[1:, 1:].astype(np.float64)
    routes = []

    # Generate all possible combinations of installations
    for r in range(1, max_route_length):
        combinations = itertools.permutations(range(1, num_installations + 1), r)

        # Create routes starting from [0] and including the combinations
        for combo in combinations:
            route = [0] + list(combo)
            routes.append(route)

    return routes


def removeRoutes(ruteList):
    df = pd.read_excel('/Users/prebenolsen/Desktop/Master/Modeller/10Inst_Demands-Distances.xlsx', header=None)
    distance_matrix = df.values[1:, 1:].astype(np.float64)
    [_, nPorts] = np.shape(distance_matrix)




    min_cost_routes = {}
    DistanceRoutes = []
    for route in ruteList:
        key = tuple(sorted(route))
        cost = routeCost(route,distance_matrix)
        if key not in min_cost_routes or cost < min_cost_routes[key][0]:
            min_cost_routes[key] = (cost, route)
            DistanceRoutes.append(cost)

    return [route[1] for route in min_cost_routes.values()],[route[0] for route in min_cost_routes.values()]
def routeCost(ruten,distance_matrix):
    cost = 0
    for i in range(len(ruten) - 1):
        cost += distance_matrix[ruten[i]][ruten[i + 1]]
        if i == (len(ruten) - 2):
            cost += distance_matrix[ruten[i + 1]][0]

    return cost




def installMatrix(RuterListe):

    sizeMatrix = len(RuterListe)
    df = pd.read_excel('/Users/prebenolsen/Desktop/Master/Modeller/10Inst_Demands-Distances.xlsx', header=None)
    DistMatrix = df.values[1:, 1:].astype(np.float64)

    [_, nPorts] = np.shape(DistMatrix)
    nrInstallations = nPorts - 1
    InstallationsServed = np.zeros((nrInstallations, sizeMatrix), dtype=int)

    for i in range(sizeMatrix):
        for nrI in range(1, nrInstallations + 1):
            for j in range(len(RuterListe[i])):
                if RuterListe[i][j] == nrI:
                    InstallationsServed[nrI - 1][i] = 1
    return InstallationsServed




def routeSpes(capacity, speed, portserved, routes):
    df = pd.read_excel('/Users/prebenolsen/Desktop/Master/Modeller/10Inst_Demands-Distances.xlsx', header=None)
    DistMatrix = df.values[1:, 1:].astype(np.float64)
    columns = np.sum(portserved, axis=0)
    cargo_matrix = np.zeros_like(portserved)
    for i in range(portserved.shape[1]):
        if columns[i] > 0:
            cargo_matrix[:, i] = portserved[:, i] * capacity / columns[i]
        else:
            cargo_matrix[:, i] = portserved[:, i]

    routeDuration = np.zeros(len(cargo_matrix[0]))
    for i in range(len(routeDuration)):
        routeDuration[i] = routeCost(routes[i], DistMatrix) / speed + np.sum(
            portserved[:, i]) * 8 + 10  # tidsbruk ruter i timer 8 timer per installasjon

    return cargo_matrix, routeDuration





def interpolate_Energyvalue(speed, column_choice):
    excel_file = pd.ExcelFile('/Users/prebenolsen/Desktop/Master/Modeller/ModelEksempel.xlsx')
    df = excel_file.parse('Energiforbruk')
    # create a boolean mask for rows that match the given speed
    speed_mask = df['Speed'] == speed

    # if there is an exact match for the speed, return the corresponding value
    if speed_mask.any():
        return df.loc[speed_mask, column_choice].iloc[0]

    # if there is no exact match, use linear interpolation to estimate the value
    else:
        # find the two nearest speeds to the given speed
        nearest_speeds = df.loc[df['Speed'].sub(speed).abs().sort_values().index[:2]]

        # use linear interpolation to estimate the value of the chosen column for the given speed
        x = nearest_speeds['Speed'].values
        y = nearest_speeds[column_choice].values
        return np.interp(speed, x, y)


def EMISSION(speed, seastate):
    EnergyConsumtion = float(interpolate_Energyvalue(speed, seastate))
    print(EnergyConsumtion, 'TEst')
    emissionkgkWh = np.array([[650, 650, 650, 650],
                              [1050, 800, 250, 0],
                              [900, 550, 200, 0],
                              [440,440,440,440],
                              [130,130,130,130]])  # g/kWh

    emissionMatrix = emissionkgkWh * EnergyConsumtion / 1000000
    with open('/Users/prebenolsen/Desktop/Master/XpressOP/Emissions.1.txt', 'w') as f:
        f.write('EmissionRoutes: ')
        f.write(str(emissionMatrix))


#EMISSION(10,'Hs=3')
def NEWFUEL(speed, seastate):
    excel_file = pd.ExcelFile('/Users/prebenolsen/Desktop/Master/Modeller/ModelEksempel.xlsx')
    df = excel_file.parse('PythonFuelPris')
    matrix = df.iloc[0:, 1:]
    matrix.values[1:, 1:].astype(np.float64)
    print(matrix)
    print(matrix.iloc[2][2])
    rutedis = [71.91, 71.67, 64.93, 66.03, 66.86, 77.87, 79.2, 71.74, 84.39, 75.52, 72.55, 80.32, 73.89, 70.14, 79.08]
    EnergyConsumtion = interpolate_Energyvalue(speed, seastate)
    print(EnergyConsumtion)
    CostMatrix = matrix * EnergyConsumtion

    print(CostMatrix)
    with open('/Users/prebenolsen/Desktop/Fuel.Ny.txt', 'w') as f:
        f.write('FuelCost: ')
        f.write(str(CostMatrix))


def vesselCompability(rute, ruteDistance):
    NH3maxrange = 300
    H2maxrange = 250
    MGOmaxrange = 600
    CCSmaxrange=100
    LNGmaxrange=500
    lenRute = len(rute)
    RuteComp = np.zeros((5, lenRute), dtype=int)

    for i in range(len(ruteDistance)):
        if ruteDistance[i] < NH3maxrange:
            RuteComp[2][i] = 1
        if ruteDistance[i] < H2maxrange:
            RuteComp[1][i] = 1
        if ruteDistance[i] < MGOmaxrange:
            RuteComp[0][i] = 1
        if ruteDistance[i] < LNGmaxrange:
            RuteComp[3][i] = 1
        if ruteDistance[i] < CCSmaxrange:
            RuteComp[4][i] = 1
    return RuteComp
def EmissionDP(cargoMatrix):
    Power=800#kw
    EmissionPerRoute=np.zeros(cargoMatrix.shape[1])
    for i in range(len(EmissionPerRoute)):
        for j in range(10):
            EmissionPerRoute[i]=Power*100/10
    print(EmissionPerRoute)

# Write to txt file.
def writeToFile(portserved, cargoMatrise, timeDuration, rutedistanse, ruteComp):
    num_routes = len(portserved[0])
    with open('/Users/prebenolsen/Desktop/TestRuter.txt', 'w') as f:
        f.write(f'Numberofroutes:\t{num_routes}\n\n')
        f.write('PortsServed:\t[\n')
        for row in portserved:
            f.write('\t'.join(str(val) for val in row) + '\n')
        f.write(']\n')
        f.write('CargoDelivered:\t[\n')
        for row1 in cargoMatrise:
            f.write('\t'.join(str(val) for val in row1) + '\n')
        f.write(']\n')
        f.write('RuteDuration:\t[\n')
        for item in timeDuration:
            f.write('  ' + str(np.around(item, 2)))
        f.write(']\n')
        f.write('RuteDistance:\t[\n')
        for item in rutedistanse:
            f.write('  ' + str(np.around(item, 2)))
        f.write(']\n')
        f.write('RuteComp:\t[\n')
        for row in ruteComp:
            f.write('\t'.join(str(val) for val in row) + '\n')
        f.write(']\n')


